diff -Nru t1lib-grace/T1lib/type1/type1.c t1lib-deb/T1lib/type1/type1.c
--- t1lib-grace/T1lib/type1/type1.c	2001-02-19 13:43:34.000000000 -0800
+++ t1lib-deb/T1lib/type1/type1.c	2014-03-27 20:23:42.310776026 -0700
@@ -42,13 +42,29 @@
 /*                 (Font level hints & stem hints)                   */
 /*                                                                   */
 /*********************************************************************/
- 
+
+
+/* Write debug info into a PostScript file? */
+/* #define DUMPDEBUGPATH */
+/* If Dumping a debug path, should we dump both character and
+   outline path? Warning: Do never enable this, unless, your name
+   is Rainer Menzner and you know what you are doing! */
+/* #define DUMPDEBUGPATHBOTH */
+
+/* Generate a bunch of stderr output to understand and debug
+   the generation of outline surrounding curves */
+/* #define DEBUG_OUTLINE_SURROUNDING */
+
+#define SUBPATH_CLOSED     1
+#define SUBPATH_OPEN       0
+
 /******************/
 /* Include Files: */
 /******************/
 #include  "types.h"
 #include  <stdio.h>          /* a system-dependent include, usually */
 #include  <math.h>
+#include  <stdlib.h>
 
 #include  "objects.h"
 #include  "spaces.h"
@@ -60,7 +76,218 @@
 #include  "util.h"       /* PostScript objects */
 #include  "fontfcn.h"
 #include  "blues.h"          /* Blues structure for font-level hints */
- 
+
+
+/* Considerations about hinting (2002-07-11, RMz (Author of t1lib))
+
+   It turns out that the hinting code as used until now produces some
+   artifacts in which may show up in suboptimal bitmaps. I have therefore
+   redesigned the algorithm. It is generally a bad idea to hint every
+   point that falls into a stem hint.
+
+   The idea is to hint only points for
+   which at least one of the two neighboring curve/line segments is aligned
+   with the stem in question. For curves, we are speaking about the
+   tangent line, that is, the line defined by (p1-p2) or (p3-p4).
+
+   For vertical stems this means, that only points which are connected
+   exactly into vertical direction are hinted. That is, the dx of the
+   respective curve vanishes. For horizontal stems, accordingly, dy must
+   vanish at least on one hand side of the point in order to be considered
+   as a stem.
+
+   Unfortunately this principle requires information about both sides of the
+   neighborhood of the point in question. In other words, it is not possible
+   to define a segment completely until the next segment has been inspected.
+   The idea thus is not compatible with the code in this file.
+
+   Furthermore, if certain points of a character outline are hinted according
+   to the stem hint info from the charstring, the non-hinted points may not be
+   left untouched. This would lead to very strong artifacts at small sizes,
+   especially if characters are defined in terms of curves. This is predominantly
+   the case for ComputerModern, for example.
+
+   To conclude, it is best to build a point list from the character description
+   adjust the non-hinted points after hinting has been completely finished. 
+
+   
+   Another rule we should state is
+   
+   We can work around this by not directly connecting the path segments at
+   the end of the lineto/curveto's, but rather deferring this to the beginning
+   of the next path constructing function. It's not great but it should work.
+
+   The functions that produce segments are
+
+   1) RMoveTo()
+   2) RLineto()
+   3) RRCurveTo()
+   4) DoClosePath()
+
+   Their code is moved into the switch statement of the new function
+   handleCurrentSegment(). This function is called when a new segment generating
+   operation has been decoded from the charstring. At this point a serious
+   decision about how to hint the points is possible.
+
+   ...
+*/
+
+
+/* The following struct is used to record points that define a path
+   in absolute charspace coordinates. x and y describe the location and
+   hinted, if greater 0, indicates that this point has been hinted. Bit 0
+   (0x1) indicates vertically adjusted and Bit 1 (0x2) indicates
+   horizontally adjusted. If hinted == -1, this point is not to be hinted
+   at all. This, for example, is the case for a a (H)SBW command.
+
+   The member type can be one of
+
+   PPOINT_SBW                --> initial path point as setup by (H)SBW
+   PPOINT_MOVE               --> point that finishes a MOVE segment
+   PPOINT_LINE               --> point that finishes a LINE segment
+   PPOINT_BEZIER_B           --> second point of a BEZIER segment
+   PPOINT_BEZIER_C           --> third point of a BEZIER segment
+   PPOINT_BEZIER_D           --> fourth point of a BEZIER segment
+   PPOINT_CLOSEPATH          --> a ClosePath command
+   PPOINT_ENDCHAR            --> an EndChar command
+   PPOINT_SEAC               --> a Standard Encoding Accented Char command
+   PPOINT_NONE               --> an invalid entry
+   
+
+   Note: BEZIER_B and BEZIER_C points generally cannot be flagged as
+   being hinted because are off-curve points.
+*/
+typedef struct 
+{
+  double x;              /* x-coordinate */
+  double y;              /* y-coordinate */
+  double ax;             /* adjusted x-coordinate */
+  double ay;             /* adjusted y-coordinate */
+  double dxpr;           /* x-shift in right path due to incoming segment (previous) */
+  double dypr;           /* y-shift in right path due to incoming segment (previous) */
+  double dxnr;           /* x-shift in right path due to outgoing segment (next) */
+  double dynr;           /* y-shift in right path due to incoming segment (next) */
+  double dxir;           /* x-shift in right path resulting from prologation of the linkend tangents (intersect) */
+  double dyir;           /* y-shift in right path resulting from prologation of the linkend tangents (intersect) */
+  double dist2prev;      /* distance to the previous point in path (used only for stroking) */
+  double dist2next;      /* distance to the next point in path (used only for stroking) */
+  enum 
+  {
+    PPOINT_SBW,
+    PPOINT_MOVE,
+    PPOINT_LINE,
+    PPOINT_BEZIER_B,
+    PPOINT_BEZIER_C,
+    PPOINT_BEZIER_D,
+    PPOINT_CLOSEPATH,
+    PPOINT_ENDCHAR,
+    PPOINT_SEAC,
+    PPOINT_NONE
+  } type;                /* type of path point */
+  signed char   hinted;  /* is this point hinted? */
+  unsigned char shape;   /* is the outline concave or convex or straight at this point? This flag
+			    is only relevant for onCurve points in the context of stroking! */
+} PPOINT;
+
+#define CURVE_NONE            0x00
+#define CURVE_STRAIGHT        0x01
+#define CURVE_CONVEX          0x02
+#define CURVE_CONCAVE         0x03
+
+#ifdef DEBUG_OUTLINE_SURROUNDING
+static char* pptypes[] = {
+  "PPOINT_SBW",
+  "PPOINT_MOVE",
+  "PPOINT_LINE",
+  "PPOINT_BEZIER_B",
+  "PPOINT_BEZIER_C",
+  "PPOINT_BEZIER_D",
+  "PPOINT_CLOSEPATH",
+  "PPOINT_ENDCHAR",
+  "PPOINT_SEAC"
+};
+static char* ppshapes[] = {
+  "SHAPE_OFFCURVE",
+  "SHAPE_STRAIGHT",
+  "SHAPE_CONVEX",
+  "SHAPE_CONCAVE"
+};
+#endif
+
+
+/* The PPOINT structs are organized in an array which is allocated
+   in chunks of 256 entries. A new point is allocated by a call to
+   nextPPoint and returns the index in the array of the newly
+   allocated point. */
+static PPOINT* ppoints       = NULL;
+static long numppoints       = 0;
+static long numppointchunks  = 0;
+static int  closepathatfirst = 0;
+
+static long nextPPoint( void) 
+{
+  ++numppoints;
+  /* Check whether to reallocate */
+  if ( numppoints > (numppointchunks * 256) ) {
+    ++numppointchunks;
+    ppoints = (PPOINT*) realloc( ppoints, (numppointchunks * 256) * sizeof( PPOINT));
+  }
+  /* return the current index */
+  return numppoints-1;
+}
+
+static void createFillPath( void);
+static void createStrokePath( double strokewidth, int subpathclosed);
+static void createClosedStrokeSubPath( long startind, long stopind,
+				       double strokewidth, int subpathclosed);
+static long computeDistances( long startind, long stopind, int subpathclosed);
+static void transformOnCurvePathPoint( double strokewidth,
+				       long prevind, long currind, long lastind);
+static void transformOffCurvePathPoint( double strokewidth, long currind);
+/* values for flag:
+   INTERSECT_PREVIOUS:     only take previous path segment into account.
+   INTERSECT_NEXT:         only take next path segment into account. 
+   INTERSECT_BOTH:         do a real intersection
+*/
+#define INTERSECT_PREVIOUS    -1
+#define INTERSECT_NEXT         1
+#define INTERSECT_BOTH         0
+static void intersectRight( long index, double halfwidth, long flag);
+/* values for orientation:
+   PATH_LEFT:              we are constructing the left path.
+   PATH_RIGHT:             we are constructing the right path.
+*/
+#define PATH_LEFT              1
+#define PATH_RIGHT             0
+/* values for position:
+   PATH_START:             current point starts the current path (use next-values).
+   PATH_END:               current point ends the current path (use prev-values).
+*/
+#define PATH_START             0
+#define PATH_END               1
+static void linkNode( long index, int position, int orientation);
+
+
+static long handleNonSubPathSegments( long pindex);
+static void handleCurrentSegment( long pindex);
+static void adjustBezier( long pindex);
+
+static double  size;
+static double scxx, scyx, scxy, scyy;
+static double  up;
+
+#ifdef DUMPDEBUGPATH
+static FILE*   psfile = NULL;
+static void PSDumpProlog( FILE* fp);
+static void PSDumpEpilog( FILE* fp);
+#endif
+
+/* variables for querying SEAC from external */
+static int isseac                = 0;
+static unsigned char seacbase    = 0;
+static unsigned char seacaccent  = 0;
+
+
 /**********************************/
 /* Type1 Constants and Structures */
 /**********************************/
@@ -71,7 +298,7 @@
 #define MAXLABEL 256       /* Maximum number of new hints */
 #define MAXSTEMS 512       /* Maximum number of VSTEM and HSTEM hints */
 #define EPS 0.001          /* Small number for comparisons */
- 
+
 /************************************/
 /* Adobe Type 1 CharString commands */
 /************************************/
@@ -143,7 +370,7 @@
 
 #define CC IfTrace1(TRUE, "Char \"%s\": ", currentchar)
 
-/* To make some compiler happy we have to care about return  types! */
+/* To make some compiler happy we have to care about return types! */
 #define Errori {errflag = TRUE; return 0;}    /* integer */
 #define Errord {errflag = TRUE; return 0.0;}  /* double */
 #define Errorv {errflag = TRUE; return;}      /* void */
@@ -159,21 +386,47 @@
 /********************/
 /* global variables */
 /********************/
-struct stem {                     /* representation of a STEM hint */
-    int vertical;                 /* TRUE if vertical, FALSE otherwise */
-    DOUBLE x, dx;                 /* interval of vertical stem */
-    DOUBLE y, dy;                 /* interval of horizontal stem */
-    struct segment *lbhint, *lbrevhint;   /* left  or bottom hint adjustment */
-    struct segment *rthint, *rtrevhint;   /* right or top    hint adjustment */
+struct stem {              /* representation of a STEM hint */
+  int vertical;                 /* TRUE if vertical, FALSE otherwise */
+  DOUBLE x, dx;                 /* interval of vertical stem */
+  DOUBLE y, dy;                 /* interval of horizontal stem */
+  DOUBLE alx, aldx;             /* interval of grid-aligned vertical stem */
+  DOUBLE aly, aldy;             /* interval of grid-aligned horizontal stem */
+  double lbhintval;             /* adjustment value for left or bottom hint */
+  double rthintval;             /* adjustment value for right ir top hint */
 };
  
+/******************************************************/
+/* Subroutines and statics for the Type1Char routines */
+/******************************************************/
+ 
+static int strindex; /* index into PostScript string being interpreted */
+static double currx, curry;           /* accumulated x and y values */
+static double hcurrx, hcurry;         /* accumulated values with hinting */
+
+
+struct callstackentry {
+  psobj *currstrP;        /* current CharStringP */
+  int currindex;          /* current strindex */
+  unsigned short currkey; /* current decryption key */
+  };
+ 
+static DOUBLE Stack[MAXSTACK];
+static int Top;
+static struct callstackentry CallStack[MAXCALLSTACK];
+static int CallTop;
+static DOUBLE PSFakeStack[MAXPSFAKESTACK];
+static int PSFakeTop;
+ 
+
 extern struct XYspace *IDENTITY;
  
 static DOUBLE escapementX, escapementY;
 static DOUBLE sidebearingX, sidebearingY;
 static DOUBLE accentoffsetX, accentoffsetY;
  
-static struct segment *path;
+static struct segment *path;    /* path of basechar */
+static struct segment *apath;   /* pass of accent char */
 static int errflag;
  
 /*************************************************/
@@ -207,11 +460,6 @@
 static int CallOtherSubr();
 static int SetCurrentPoint();
 
-/*****************************************/
-/* statics for Flex procedures (FlxProc) */
-/*****************************************/
-static struct segment *FlxOldPath; /* save path before Flex feature */
- 
 /******************************************************/
 /* statics for Font level hints (Blues) (see blues.h) */
 /******************************************************/
@@ -332,6 +580,16 @@
 	    blues->FamilyBlues[i];
 	  alignmentzones[numalignmentzones].topy =
 	    blues->FamilyBlues[i+1];
+#ifdef DUMPDEBUGPATH
+	  if ( psfile != NULL ) {
+	    if ( alignmentzones[numalignmentzones].topzone == TRUE )
+	      fprintf( psfile, "%f %f t1topzone\n", (blues->FamilyBlues[i])*up,
+		       (blues->BlueValues[i+1])*up);
+	    else
+	      fprintf( psfile, "%f %f t1bottomzone\n", (blues->FamilyBlues[i])*up,
+		       (blues->BlueValues[i+1])*up);
+	  }
+#endif
 	  continue;
 	}
       }
@@ -339,6 +597,16 @@
     /* use this font's Blue zones */
     alignmentzones[numalignmentzones].bottomy = blues->BlueValues[i];
     alignmentzones[numalignmentzones].topy = blues->BlueValues[i+1];
+#ifdef DUMPDEBUGPATH
+    if ( psfile != NULL ) {
+      if ( alignmentzones[numalignmentzones].topzone == TRUE )
+	fprintf( psfile, "%f %f t1topzone\n", (blues->BlueValues[i])*up,
+		 (blues->BlueValues[i+1])*up);
+      else
+	fprintf( psfile, "%f %f t1bottomzone\n", (blues->BlueValues[i])*up,
+		 (blues->BlueValues[i+1])*up);
+    }
+#endif
   }
  
   /* do the OtherBlues zones */
@@ -362,6 +630,12 @@
 	    blues->FamilyOtherBlues[i];
 	  alignmentzones[numalignmentzones].topy =
 	    blues->FamilyOtherBlues[i+1];
+#ifdef DUMPDEBUGPATH
+	  if ( psfile != NULL ) {
+	    fprintf( psfile, "%f %f t1bottomzone\n", (blues->FamilyOtherBlues[i])*up,
+		     (blues->FamilyOtherBlues[i+1])*up);
+	  }
+#endif
 	  continue;
 	}
       }
@@ -369,6 +643,12 @@
     /* use this font's Blue zones (as opposed to the Family Blues */
     alignmentzones[numalignmentzones].bottomy = blues->OtherBlues[i];
     alignmentzones[numalignmentzones].topy = blues->OtherBlues[i+1];
+#ifdef DUMPDEBUGPATH
+    if ( psfile != NULL ) {
+      fprintf( psfile, "%f %f t1bottomzone\n", (blues->OtherBlues[i])*up,
+	       (blues->OtherBlues[i+1])*up);
+    }
+#endif
   }
   return(0);
   
@@ -395,20 +675,7 @@
   
 }
  
-static int FinitStems()  /* Terminate the STEM hint data structures */
-{
-  int i;
- 
-  for (i = 0; i < numstems; i++) {
-    Destroy(stems[i].lbhint);
-    Destroy(stems[i].lbrevhint);
-    Destroy(stems[i].rthint);
-    Destroy(stems[i].rtrevhint);
-  }
-  return(0);
-  
-}
- 
+
 /*******************************************************************/
 /* Compute the dislocation that a stemhint should cause for points */
 /* inside the stem.                                                */
@@ -441,10 +708,9 @@
   else if (FABS(cyx) < 0.00001 || FABS(cxy) < 0.00001)
     rotated = FALSE; /* Char is upright (0 or 180 degrees), possibly oblique. */
   else {
-    stems[stemno].lbhint = NULL; /* Char is at non-axial angle, ignore hints. */
-    stems[stemno].lbrevhint = NULL;
-    stems[stemno].rthint = NULL;
-    stems[stemno].rtrevhint = NULL;
+    stems[stemno].lbhintval = 0.0; /* Char is at non-axial angle, ignore hints. */
+    stems[stemno].rthintval = 0.0;
+    ProcessHints = 0;
     return(0);
   }
  
@@ -454,10 +720,18 @@
     verticalondevice = !rotated;
     stemstart = stems[stemno].x;
     stemwidth = stems[stemno].dx;
+#ifdef DUMPDEBUGPATH
+    if ( psfile != NULL )
+      fprintf( psfile, "%f %f t1vstem\n", stemstart*up, stemwidth*up);
+#endif
   } else {
     verticalondevice = rotated;
     stemstart = stems[stemno].y;
     stemwidth = stems[stemno].dy;
+#ifdef DUMPDEBUGPATH
+    if ( psfile != NULL )
+      fprintf( psfile, "%f %f t1hstem\n", stemstart*up, stemwidth*up);
+#endif
   }
  
   /* Determine how many pixels (non-negative) correspond to 1 character space
@@ -476,7 +750,7 @@
     unitpixels = FABS(Ypixels);
  
   onepixel = 1.0 / unitpixels;
- 
+
   /**********************/
   /* ADJUST STEM WIDTHS */
   /**********************/
@@ -501,7 +775,7 @@
         widthdiff = blues->StemSnapH[i] - stemwidth;
     }
   }
- 
+
   /* Only expand or contract stems if they differ by less than 1 pixel from
      the closest standard width, otherwise make the width difference = 0. */
   if (FABS(widthdiff) > onepixel)
@@ -528,7 +802,7 @@
  
   stemshift = 0.0;
  
-  if (!stems[stemno].vertical) {
+  if ( !stems[stemno].vertical ) {
  
     /* Get bottom and top boundaries of the stem. */
     stembottom = stemstart;
@@ -648,11 +922,18 @@
         rthintvalue = stemshift + widthdiff; /* top    */
       }
 
-      stems[stemno].lbhint    = (struct segment *)Permanent(Loc(CharSpace, 0.0,  lbhintvalue));
-      stems[stemno].lbrevhint = (struct segment *)Permanent(Loc(CharSpace, 0.0, -lbhintvalue));
-      stems[stemno].rthint    = (struct segment *)Permanent(Loc(CharSpace, 0.0,  rthintvalue));
-      stems[stemno].rtrevhint = (struct segment *)Permanent(Loc(CharSpace, 0.0, -rthintvalue));
- 
+      stems[stemno].lbhintval = lbhintvalue;
+      stems[stemno].rthintval = rthintvalue;
+
+      /* store grid-aligned stems values */
+      stems[stemno].aly       = stemstart + lbhintvalue;
+      stems[stemno].aldy      = stemwidth + widthdiff;
+      
+#ifdef DUMPDEBUGPATH
+      if ( psfile != NULL )
+	fprintf( psfile, "%f %f t1alignedhstem\n", (stems[stemno].aly)*up,
+		 (stems[stemno].aldy)*up);
+#endif
       return(0);
  
     } /* endif (i < numalignmentzones) */
@@ -671,157 +952,180 @@
   rthintvalue = stemshift + widthdiff / 2; /* right or top    */
  
   if (stems[stemno].vertical) {
-    stems[stemno].lbhint    = (struct segment *)Permanent(Loc(CharSpace,  lbhintvalue, 0.0));
-    stems[stemno].lbrevhint = (struct segment *)Permanent(Loc(CharSpace, -lbhintvalue, 0.0));
-    stems[stemno].rthint    = (struct segment *)Permanent(Loc(CharSpace,  rthintvalue, 0.0));
-    stems[stemno].rtrevhint = (struct segment *)Permanent(Loc(CharSpace, -rthintvalue, 0.0));
+    stems[stemno].lbhintval = lbhintvalue;
+    stems[stemno].rthintval = rthintvalue;
+
+    /* store grid-aligned stem values */
+    stems[stemno].alx       = stemstart + stemshift;
+    stems[stemno].aldx      = stemwidth + widthdiff;
+      
+#ifdef DUMPDEBUGPATH
+    if ( psfile != NULL )
+      fprintf( psfile, "%f %f t1alignedvstem\n", (stems[stemno].alx)*up,
+	       (stems[stemno].aldx)*up);
+#endif
   } else {
-    stems[stemno].lbhint    = (struct segment *)Permanent(Loc(CharSpace, 0.0,  lbhintvalue));
-    stems[stemno].lbrevhint = (struct segment *)Permanent(Loc(CharSpace, 0.0, -lbhintvalue));
-    stems[stemno].rthint    = (struct segment *)Permanent(Loc(CharSpace, 0.0,  rthintvalue));
-    stems[stemno].rtrevhint = (struct segment *)Permanent(Loc(CharSpace, 0.0, -rthintvalue));
+    stems[stemno].lbhintval = lbhintvalue;
+    stems[stemno].rthintval = rthintvalue;
+
+    /* store grid-aligned stem values */
+    stems[stemno].aly       = stemstart + stemshift;
+    stems[stemno].aldy      = stemwidth + widthdiff;
+      
+#ifdef DUMPDEBUGPATH
+    if ( psfile != NULL )
+      fprintf( psfile, "%f %f t1alignedhstem\n", (stems[stemno].aly)*up,
+    	       (stems[stemno].aldy)*up);
+#endif
   }
   return(0);
   
 }
  
+
 #define LEFT   1
 #define RIGHT  2
 #define BOTTOM 3
 #define TOP    4
- 
-/*********************************************************************/
-/* Adjust a point using the given stem hint.  Use the left/bottom    */
-/* hint value or the right/top hint value depending on where the     */
-/* point lies in the stem.                                           */
-/*********************************************************************/
-static struct segment *Applyhint(p, stemnumber, half)
-struct segment *p;
-int stemnumber, half;
-{
-  if (half == LEFT || half == BOTTOM)
-    return Join(p, stems[stemnumber].lbhint); /* left  or bottom hint */
-  else
-    return Join(p, stems[stemnumber].rthint); /* right or top    hint */
-}
- 
-/*********************************************************************/
-/* Adjust a point using the given reverse hint.  Use the left/bottom */
-/* hint value or the right/top hint value depending on where the     */
-/* point lies in the stem.                                           */
-/*********************************************************************/
-static struct segment *Applyrevhint(p, stemnumber, half)
-struct segment *p;
-int stemnumber, half;
-{
-  if (half == LEFT || half == BOTTOM)
-    return Join(p, stems[stemnumber].lbrevhint); /* left  or bottom hint */
-  else
-    return Join(p, stems[stemnumber].rtrevhint); /* right or top    hint */
-}
- 
+
+
 /***********************************************************************/
 /* Find the vertical and horizontal stems that the current point       */
 /* (x, y) may be involved in.  At most one horizontal and one vertical */
 /* stem can apply to a single point, since there are no overlaps       */
 /* allowed.                                                            */
-/*   The actual hintvalue is returned as a location.                   */
+/*   The point list updated by this function.                          */
 /* Hints are ignored inside a DotSection.                              */
 /***********************************************************************/
-static struct segment *FindStems(x, y, dx, dy)
-DOUBLE x, y, dx, dy;
+static void FindStems( double x, double y,
+		       double dx, double dy,
+		       double nextdx, double nextdy)
 {
   int i;
   int newvert, newhor;
-  struct segment *p;
   int newhorhalf, newverthalf;
+
+  /* The following values will be used to decide whether a curve
+     crosses or touches a stem in an aligned manner or not */
+  double dtana     = 0.0;   /* tangent of pre-delta against horizontal line */ 
+  double dtanb     = 0.0;   /* tangent of pre-delta against vertical line */ 
+  double nextdtana = 0.0;   /* tangent of post-delta against horizontal line */ 
+  double nextdtanb = 0.0;   /* tangent of post-delta against vertical line */ 
+  
+  if (ppoints == NULL || numppoints < 1) Error0v("FindStems: No previous point!\n");
  
-  if (InDotSection) return(NULL);
- 
+  /* setup default hinted position */
+  ppoints[numppoints-1].ax     = ppoints[numppoints-1].x;
+  ppoints[numppoints-1].ay     = ppoints[numppoints-1].y;
+  if ( ppoints[numppoints-1].hinted == -1 )
+    /* point is not to be hinted! */
+    return;
+  else
+    ppoints[numppoints-1].hinted = 0;
+
+  if ( InDotSection )
+    return;
+
+  if ( ProcessHints == 0 ) {
+    return;
+  }
+
+  /* setup (absolute) tangent values and define limits that indicate nearly
+     horizontal or nearly vertical alignment */
+#define NEARLYVERTICAL     0.2   /* This corresponds to about 11.3 degress deviation */
+#define NEARLYHORIZONTAL   0.2   /* from the ideal direction.                        */
+  if ( dy != 0 ) {
+    dtana = dx/dy;
+    if ( dtanb < 0.0 )
+      dtana = -dtana;
+  }
+  else
+    dtana = NEARLYHORIZONTAL;
+  if ( dx != 0 ) {
+    dtanb = dy/dx;
+    if ( dtanb < 0.0 )
+      dtanb = -dtanb;
+  }
+  else
+    dtanb = NEARLYVERTICAL;
+  if ( nextdy != 0 ) {
+    nextdtana = nextdx/nextdy;
+    if ( nextdtana < 0.0 )
+      nextdtana = -nextdtana;
+  }
+  else
+    nextdtana = NEARLYHORIZONTAL;
+  if ( nextdx != 0 ) {
+    nextdtanb = nextdy/nextdx;
+    if ( nextdtanb < 0.0 )
+      nextdtanb = -nextdtanb;
+  }
+  else
+    nextdtanb = NEARLYVERTICAL;
+  
   newvert = newhor = -1;
   newhorhalf = newverthalf = -1;
- 
+
   for (i = currstartstem; i < numstems; i++) {
     if (stems[i].vertical) { /* VSTEM hint */
-      if ((x >= stems[i].x - EPS) &&
-          (x <= stems[i].x+stems[i].dx + EPS)) {
-        newvert = i;
-        if (dy != 0.0) {
-          if (dy < 0) newverthalf = LEFT;
-          else        newverthalf = RIGHT;
-        } else {
-          if (x < stems[i].x+stems[i].dx / 2) newverthalf = LEFT;
-          else                                newverthalf = RIGHT;
-        }
+      /* OK, stem is crossed in an aligned way */
+      if ( (dtana <= NEARLYVERTICAL) || (nextdtana <= NEARLYVERTICAL)) {
+	if ((x >= stems[i].x ) &&
+	    (x <= stems[i].x+stems[i].dx )) {
+	  newvert = i;
+	  if (x < stems[i].x+stems[i].dx / 2)
+	    newverthalf = LEFT;
+	  else
+	    newverthalf = RIGHT;
+	}
       }
-    } else {                 /* HSTEM hint */
-      if ((y >= stems[i].y - EPS) &&
-          (y <= stems[i].y+stems[i].dy + EPS)) {
-        newhor = i;
-        if (dx != 0.0) {
-          if (dx < 0) newhorhalf = TOP;
-          else        newhorhalf = BOTTOM;
-        } else {
-          if (y < stems[i].y+stems[i].dy / 2) newhorhalf = BOTTOM;
-          else                                newhorhalf = TOP;
-        }
+    }
+    else {                 /* HSTEM hint */
+      if ( (dtanb <= NEARLYHORIZONTAL) || (nextdtanb <= NEARLYHORIZONTAL)) {
+	/* OK, stem is crossed in an aligned way */
+	if ((y >= stems[i].y ) &&
+	    (y <= stems[i].y+stems[i].dy )) {
+	  newhor = i;
+	  if (y < stems[i].y+stems[i].dy / 2)
+	    newhorhalf = BOTTOM;
+	  else
+	    newhorhalf = TOP;
+	}
       }
     }
   }
- 
-  p = NULL;
- 
-  if (newvert == -1 && oldvert == -1) ; /* Outside of any hints */
-  else if (newvert == oldvert &&
-    newverthalf == oldverthalf); /* No hint change */
-  else if (oldvert == -1) { /* New vertical hint in effect */
-    p = Applyhint(p, newvert, newverthalf);
-  } else if (newvert == -1) { /* Old vertical hint no longer in effect */
-    p = Applyrevhint(p, oldvert, oldverthalf);
-  } else { /* New vertical hint in effect, old hint no longer in effect */
-    p = Applyrevhint(p, oldvert, oldverthalf);
-    p = Applyhint(p, newvert, newverthalf);
-  }
- 
-  if (newhor == -1 && oldhor == -1) ; /* Outside of any hints */
-  else if (newhor == oldhor &&
-    newhorhalf == oldhorhalf) ; /* No hint change */
-  else if (oldhor == -1) { /* New horizontal hint in effect */
-    p = Applyhint(p, newhor, newhorhalf);
-  } else if (newhor == -1) { /* Old horizontal hint no longer in effect */
-    p = Applyrevhint(p, oldhor, oldhorhalf);
-  }
-  else { /* New horizontal hint in effect, old hint no longer in effect */
-    p = Applyrevhint(p, oldhor, oldhorhalf);
-    p = Applyhint(p, newhor, newhorhalf);
+
+  if ( newvert != -1 ) {
+    /* mark the latest point in the point list to be v-hinted! */
+    if ( newverthalf == LEFT ) {
+      /* left hint */
+      ppoints[numppoints-1].ax  += stems[newvert].lbhintval;
+    }
+    else {
+       /* right hint */
+      ppoints[numppoints-1].ax  += stems[newvert].rthintval;
+    }
+    ppoints[numppoints-1].hinted |= 0x01;
   }
- 
-  oldvert = newvert; oldverthalf = newverthalf;
-  oldhor  = newhor;  oldhorhalf  = newhorhalf;
- 
-  return p;
+  if ( newhor != -1 ) {
+    /* mark the latest point in the point list to be h-hinted! */
+    if ( newhorhalf == BOTTOM ) {
+      /* bottom hint */
+      ppoints[numppoints-1].ay  += stems[newhor].lbhintval;
+    }
+    else {
+       /* top hint */
+      ppoints[numppoints-1].ay  += stems[newhor].rthintval;
+    }
+    ppoints[numppoints-1].hinted |= 0x02;
+  }
+  
+  return;
+  
 }
- 
-/******************************************************/
-/* Subroutines and statics for the Type1Char routines */
-/******************************************************/
- 
-static int strindex; /* index into PostScript string being interpreted */
-static DOUBLE currx, curry; /* accumulated x and y values for hints */
- 
-struct callstackentry {
-  psobj *currstrP;        /* current CharStringP */
-  int currindex;          /* current strindex */
-  unsigned short currkey; /* current decryption key */
-  };
- 
-static DOUBLE Stack[MAXSTACK];
-static int Top;
-static struct callstackentry CallStack[MAXCALLSTACK];
-static int CallTop;
-static DOUBLE PSFakeStack[MAXPSFAKESTACK];
-static int PSFakeTop;
- 
+
+
+/* Type 1 internal functions */
 static int ClearStack()
 {
   Top = -1;
@@ -986,7 +1290,7 @@
 static int DoRead(CodeP)
   int *CodeP;
 {
-  if (strindex >= CharStringP->len) return(FALSE); /* end of string */
+  if (!CharStringP || strindex >= CharStringP->len) return(FALSE); /* end of string */
   /* We handle the non-documented Adobe convention to use lenIV=-1 to
      suppress charstring encryption. */
   if (blues->lenIV==-1) {
@@ -1394,20 +1698,25 @@
 static int RLineTo(dx, dy)
   DOUBLE dx, dy;
 {
-  struct segment *B;
- 
-  IfTrace2((FontDebug), "RLineTo %f %f\n", dx, dy);
- 
-  B = Loc(CharSpace, dx, dy);
- 
-  if (ProcessHints) {
-    currx += dx;
-    curry += dy;
-    /* B = Join(B, FindStems(currx, curry)); */
-    B = Join(B, FindStems(currx, curry, dx, dy));
-  }
- 
-  path = Join(path, Line(B));
+  long pindex = 0;
+  
+  /* compute hinting for previous segment! */
+  if (ppoints == NULL || numppoints < 2) Error0i("RLineTo: No previous point!\n");
+  FindStems( currx, curry, currx-ppoints[numppoints-2].x, curry-ppoints[numppoints-2].y, dx, dy);
+
+  /* Allocate a new path point and pre-setup data */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx + dx;
+  ppoints[pindex].y       = curry + dy;
+  ppoints[pindex].ax      = ppoints[pindex].x;
+  ppoints[pindex].ay      = ppoints[pindex].y;
+  ppoints[pindex].type    = PPOINT_LINE;
+  ppoints[pindex].hinted  = 0;
+
+  /* update ideal position */
+  currx                  += dx;
+  curry                  += dy;
+
   return(0);
 }
  
